---
title: Navigator.share()
slug: Web/API/Navigator/share
tags:
  - Method
  - Navigator
  - Reference
  - Share
  - Web
---
<div>{{APIRef("HTML DOM")}}{{securecontext_header}}</div>

<p>The <strong><code>navigator.share()</code></strong> method of the Web Share API invokes the native sharing mechanism of the device.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">const <em>sharePromise</em> = navigator.share(<var>data</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>data</var></code></dt>
 <dd>An object containing data to share. At least one of the following fields must be specified. Available options are:</dd>
</dl>

<ul>
 <li><code>url</code>: A {{domxref("USVString")}} representing a URL to be shared.</li>
 <li><code>text</code>: A {{domxref("USVString")}} representing text to be shared.</li>
 <li><code>title</code>: A {{domxref("USVString")}} representing the title to be shared.</li>
 <li><code>files</code>: A "FrozenArray" representing the array of file to be shared.</li>
</ul>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("Promise")}} that will be fulfilled once a user has completed a share action (usually the user has chosen an application to share to). It will reject immediately if the <var>data</var> parameter is not correctly specified, and will also reject if the user cancels sharing.</p>

<h2 id="Examples">Examples</h2>

<p>In our <a href="https://mdn.github.io/dom-examples/web-share/">Web share test</a> (<a href="https://github.com/mdn/dom-examples/blob/master/web-share/index.html">see the source code</a>) there is a button which, when clicked, invokes the Web Share API to share MDN's URL. The JavaScript looks like this:</p>

<pre class="brush: js notranslate">const shareData = {
  title: 'MDN',
  text: 'Learn web development on MDN!',
  url: 'https://developer.mozilla.org',
}

const btn = document.querySelector('button');
const resultPara = document.querySelector('.result');

// Must be triggered some kind of "user activation"
btn.addEventListener('click', async () =&gt; {
  try {
    await navigator.share(shareData)
    resultPara.textContent = 'MDN shared successfully'
  } catch(err) {
    resultPara.textContent = 'Error: ' + err
  }
});</pre>

<h4 id="Sharing_Files"><strong>Sharing Files</strong></h4>

<p>To share files, first test for and call <code>navigator.canShare()</code>. Then include an array of files in the call to <code>navigator.share():</code></p>

<p>Notice: That the sample handles feature detection by testing for <code>navigator.canShare()</code> rather than for <code>navigator.share()</code>. The data object passed to <code>canShare()</code> only supports the <code>files</code> property. Image, video, audio, and text files can be shared.</p>

<pre class="brush: js notranslate">if (navigator.canShare &amp;&amp; navigator.canShare({ files: filesArray })) {
  navigator.share({
    files: filesArray,
    title: 'Pictures',
    text: 'Our Pictures.',
  })
  .then(() =&gt; console.log('Share was successful.'))
  .catch((error) =&gt; console.log('Sharing failed', error));
} else {
  console.log(`Your system doesn't support sharing files.`);
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Web Share API','#share-method','share()')}}</td>
   <td>{{Spec2('Web Share API')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Navigator.share")}}</p>

<h2 id="See_Also">See Also</h2>

<ul>
 <li>{{domxref("navigator.canShare()")}}</li>
</ul>
